#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "main.h"
#include "game.h"

BITMAP *LevelRender(LEVEL *l)
{
	int x, y;
	TILE t;
	BITMAP *blvl;

	blvl = create_bitmap(l->w * 32, l->h * 32);

	for(y = 0; y < l->h; y++)
	{
		for(x = 0; x < l->w; x++)
		{
			t = tiles[l->tiles[x + y * l->w]];
			blit(graphics, blvl, t.picx * 33, t.picy * 33, x * 32, y * 32, 32, 32);
		}
	}

	return blvl;
}

void LevelRenderObjects(LEVEL *l, BITMAP *bmp)
{
	int x, picx, picy;

	for(x = 0; x < l->nobjects; x++)
	{
		if(l->objects[x].type == 2 && l->objects[x].var1 == 1) continue; // It's a dead troll.
		picx = l->objects[x].ani_x[l->objects[x].cur_ani] * 33;
		picy = l->objects[x].ani_y[l->objects[x].cur_ani] * 33;
		masked_blit(graphics, bmp, picx, picy, l->objects[x].x, l->objects[x].y, 32, 32);
	}
}

LEVEL *LevelLoad(char *filename)
{
	FILE *fp;
	int x, slen, t;
	LEVEL *l;

	fp = fopen(filename, "rb");
	if(fp == NULL) return NULL;

	l = (LEVEL *) malloc(sizeof(LEVEL));

	slen = fgetc(fp);
	l->next_lvl = (char *) malloc(sizeof(char) * (slen + 1));
	memset(l->next_lvl, 0, sizeof(char) * (slen + 1));

	for(x = 0; x < slen; x++)
	{
		l->next_lvl[x] = fgetc(fp);
	}

	l->w = fgetc(fp);
	l->w |= fgetc(fp) << 8;
	l->h = fgetc(fp);
	l->h |= fgetc(fp) << 8;

	l->startx = fgetc(fp);
	l->startx |= fgetc(fp) << 8;
	l->starty = fgetc(fp);
	l->starty |= fgetc(fp) << 8;

	l->tiles = (int *) malloc(sizeof(int) * l->w * l->h);

	for(x = 0; x < l->w * l->h; x++)
	{
		l->tiles[x] = fgetc(fp);
	}

	l->nobjects = fgetc(fp);
	l->nobjects |= fgetc(fp) << 8;
	l->objects = (OBJECT *) malloc(sizeof(OBJECT) * l->nobjects);

	for(x = 0; x < l->nobjects; x++)
	{
		t = fgetc(fp);
		t |= fgetc(fp) << 8;
		l->objects[x] = object_templates[t];

		l->objects[x].x = fgetc(fp);
		l->objects[x].x |= fgetc(fp) << 8;
		l->objects[x].x *= 32;
		l->objects[x].y = fgetc(fp);
		l->objects[x].y |= fgetc(fp) << 8;
		l->objects[x].y *= 32;
	}

	fclose(fp);
	return l;
}

void LevelFree(LEVEL *l)
{
	free(l->next_lvl);
	free(l->tiles);
	free(l->objects);
	free(l);
}
