#include <allegro.h>
#include "main.h"
#include "game.h"

LEVEL *title_lvl;

void ScreenFadeOut();

int TitleMenu(int options[], int noptions)
{
	BITMAP *title_bg;
	int x, sel = 0;

	title_bg = LevelRender(title_lvl);

	while(1)
	{
		clear_bitmap(screenbuf);
		blit(title_bg, screenbuf, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		// draw menu
		for(x = 0; x < noptions; x++)
		{
			masked_blit((sel == x ? title_on : title_off), screenbuf, 0, 56 * options[x * 2], (SCREEN_W - title_off->w) / 2, (SCREEN_H - noptions * 56) / 2 + 56 * x, title_off->w, 56);
		}
		BLITBUF();
		while(1)
		{
			if(input_tick < 2) continue;
			if(key[KEY_ESC]) return -1;
			if(key[KEY_DOWN])
			{
				sel++;
				if(sel >= noptions) sel = 0;
				break;
			}
			if(key[KEY_UP])
			{
				sel--;
				if(sel < 0) sel = noptions - 1;
				break;
			}
			if(key[KEY_ENTER] || key[KEY_SPACE] || key[KEY_ENTER_PAD]) return options[sel * 2 + 1];
		}
		input_tick = 0;
	}

	destroy_bitmap(title_bg);
}

void MainMenu()
{
	int x, tmenu[] = {0, 0, 3, 3}, pmenu[] = {4, 1, 5, 2};

	while(1)
	{
		x = TitleMenu(tmenu, 2);

		switch(x)
		{
			case 0:
				//ScreenFadeOut();
				if(can_multi == 1) nplayers = TitleMenu(pmenu, 2);
				else nplayers = 1;
				players[0].viewport[VIEWPORT_X] = players[0].viewport[VIEWPORT_Y] = 0;
				players[0].viewport[VIEWPORT_W] = (nplayers == 1 ? 640 : 319);
				players[0].viewport[VIEWPORT_H] = 480;
				players[0].keys[PKEY_LEFT] = KEY_LEFT;
				players[0].keys[PKEY_RIGHT] = KEY_RIGHT;
				players[0].keys[PKEY_JUMP] = KEY_Z;
				players[0].keys[PKEY_SHOOT] = KEY_SPACE;
				players[0].lives = 3;

				players[1].viewport[VIEWPORT_X] = 321;
				players[1].viewport[VIEWPORT_Y] = 0;
				players[1].viewport[VIEWPORT_W] = 319;
				players[1].viewport[VIEWPORT_H] = 480;
				players[1].keys[PKEY_LEFT] = KEY_4_PAD;
				players[1].keys[PKEY_RIGHT] = KEY_6_PAD;
				players[1].keys[PKEY_JUMP] = KEY_5_PAD;
				players[1].keys[PKEY_SHOOT] = KEY_ENTER_PAD;
				players[1].lives = 3;

				//PlayGame("level0.lvl");
				Storyline();
				break;
			case 3: // Quit
			case -1:
				return;
		}
	}
}

void ScreenFadeOut()
{
	int y;

	for(y = 0 - (fadeout->h - 1) / 8; y < SCREEN_H / 8; y++)
	{
		game_tick = 0;
		masked_stretch_blit(fadeout, screenbuf, 0, 0, fadeout->w, fadeout->h, 0, y * 8, SCREEN_W, fadeout->h);
		while(game_tick < 1);
	}
}
