#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "game.h"

TILE *tiles;
OBJECT *object_templates;

int LoadTiles()
{
	FILE *fp;
	int ntiles, x;

	fp = fopen("tiles.dat", "rb");
	if(fp == NULL) return 1;

	ntiles = fgetc(fp);
	ntiles |= fgetc(fp) << 8;

	tiles = (TILE *) malloc(sizeof(TILE) * ntiles);

	for(x = 0; x < ntiles; x++)
	{
		tiles[x].type = fgetc(fp);
		tiles[x].picx = fgetc(fp);
		tiles[x].picy = fgetc(fp);
	}

	fclose(fp);
	return 0;
}

int LoadObjects()
{
	FILE *fp;
	int nobjects, x, z;

	fp = fopen("objects.dat", "rb");
	if(fp == NULL) return 1;

	nobjects = fgetc(fp);
	nobjects |= fgetc(fp) << 8;

	object_templates = (OBJECT *) malloc(sizeof(OBJECT) * nobjects);
	memset(object_templates, 0, sizeof(OBJECT) * nobjects);

	for(x = 0; x < nobjects; x++)
	{
		object_templates[x].type = fgetc(fp);
		object_templates[x].type |= fgetc(fp) << 8;
		object_templates[x].max_ani = fgetc(fp);
		for(z = 0; z < 5; z++)
		{
			object_templates[x].ani_x[z] = fgetc(fp);
			object_templates[x].ani_y[z] = fgetc(fp);
		}
	}

	fclose(fp);
	return 0;
}
